//+------------------------------------------------------------------+
//|                                                 MA-EA-TSTOPS.mq4 |
//|                                  Copyright(c) 2010 Masaru Sasaki |
//|                                      http://youtarou.blogzine.jp |
//+------------------------------------------------------------------+
// < MetaTrader4 FX(Oב֏؋)gCOVXeEA >
// u\[XR[hJRv
//  *ʓIȌlg[_[̈lƂāAvOɕsȕւ
//   QlƂČJ鎖ɂ܂B
//   ͍KɂvO~OƂėTf[vO}[
//   ł鎖AVXevO~O(EA)ł܂B
//   vO~O͏KA낾Ǝv܂B
//
// u֎~v
//  *̃vO\[XR[ĥ܂ܗp\tg̔̔
//   ؋֎~v܂B
// 
// uƐӎv
//  *̃vOɊÂšׂʔQAȂǂɂ
//    ҂͈؂̐ӔC𕉂܂B
//
// uv
//  *ٗʃg[hɂăGg[̃gCOXgbv
//   EAłB(͂܂B)
//   }`[g̒ʉ݂ŁA1I[_[̂ݑΉ܂B
//   I[_[ɂ͑ΉĂ܂B
//   gp@ƂẮAٗʃg[hɂăGg[EAғ
//   Ƃ邾łB
//   AgCOXgbv@蕝(pipsP)蕝Ŗ
//   (w͈͂̍ll)Ił܂B
//   蕝pipsPʂŐݒł܂B
//
//   (ӁFI[_[̃}WbNԍĂ܂̂ŁAEAœʉ
//          Ƃ͋ł܂B
//
// QlЁFFX^g[_[ (PanRolling)
//           FX^g[_[HvO~O (PanRolling)
//
#property copyright "Copyright(c) 2010 Masaru Sasaki"
#property link      "http://youtarou.blogzine.jp"

// 蕝ŖgCOXgbṽo[鐔
extern int HL_period = 20;

// 蕝gCOXgbvĨTCY(pips)
extern int sp_size = 5;

// gCOXgbv@̑I(W͈蕝Ŗ)
extern int TrailingStop_select = 1;

// fobO on/off tO
bool debug = false;

// 蕝ŖgCOXgbv֐(w肵o[̍lAl)
bool TrailingStopHL(int HL_period, double ask, double bid, int ticket, int type)
{
   // gCOXgbvvZ
   double spread = ask-bid;
   double HH = High[iHighest(NULL, 0, MODE_HIGH, HL_period, 1)] + spread;
   double LL = Low[iLowest(NULL, 0, MODE_LOW, HL_period, 1)];
   bool ret = false;
   OrderSelect(ticket, SELECT_BY_TICKET);
   if( type == OP_BUY )
   {
      if( LL > OrderStopLoss() )
         ret = OrderModify( ticket, OrderOpenPrice(), LL, OrderTakeProfit(), 0, Blue);
   }
   if( type == OP_SELL )
   {
      if( HH < OrderStopLoss() || OrderStopLoss() == 0 )
         ret = OrderModify( ticket, OrderOpenPrice(), HH, OrderTakeProfit(), 0, Blue);
   }
   return(ret);
}

// 蕝̃gCOXgbv֐(pipsP)
bool TrailingStopSetsize(int setsize, double point, double ask, double bid, int ticket, int type)
{
   // gCOXgbvvZ
   bool ret = false;
   double profit = 0.0;
   double set_size = setsize * point;
   double spread = ask - bid;
   int i = 1000;
   OrderSelect(ticket, SELECT_BY_TICKET);
   while( i > 0 )
   {
      if( type == OP_BUY )
       {
         profit = ask - OrderOpenPrice() - (set_size * i + spread);
         if( profit > 0 )
         {
            ret = OrderModify(ticket, OrderOpenPrice(), OrderStopLoss() + set_size, OrderTakeProfit(), 0, Blue);
            return(ret);
         }
      }
      if( type == OP_SELL )
      {
         profit = OrderOpenPrice() - bid - (set_size * i + spread);
         if( profit > 0 )
         {
            ret = OrderModify(ticket, OrderOpenPrice(), OrderStopLoss() - set_size, OrderTakeProfit(), 0, Blue);
            return(ret);
         }
      }
      i--;
   }
   return(false);
}

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {

   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {

   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   // o[̎nlŃg[h\`FbN
   if( Volume[0] > 1 || IsTradeAllowed() == false )
      return(0);
   // I[_[L̃`FbN   
   int ticket = 0; bool ret = false;
   for(int i = 0; i < OrdersTotal(); i++ )
   {
      if(OrderSelect(i, SELECT_BY_POS) == false) break;
      if(OrderSymbol() != Symbol()) continue;
      int type = OrderType();
      if(type == OP_BUY || type == OP_SELL)
      {
         ticket = OrderTicket();
         break;
      }
   }
   if(ticket == 0) return(0);
   
   if( TrailingStop_select == 1 )
   {
      // 蕝ŖgCOXgbv֐Ăяo
      ret = TrailingStopHL(HL_period, Ask, Bid, ticket, type);
   }
   else
   {
      // 蕝̃gCOXgbv֐Ăяo
      ret = TrailingStopSetsize(sp_size, Point, Ask, Bid, ticket, type);
   }
   // fobO\
   if( debug == true )
   {
      Print("Open :", Open[1], "Close :", Close[1]);
      Print("Trailing stop :", ret); 
   }
   return(0);
   
  }
//+------------------------------------------------------------------+